/*************************************************************
wasm_vensim.h Copyright Ventana Systems, Inc.
*********************************************/

#ifndef _WASM_VENSIM_DEFINES_H_
#define _WASM_VENSIM_DEFINES_H_

#define VLARGE
#define MAX_LEV_EXTRA 6 /* for runge kutta 6 used for simultaneous  */

#define NA (COMPREAL)(-1.2980742146337069E33) /* - 2 to the 109 makes == ok  */
#define PI 3.14159265358979
#define __tcfdc
#define __tcfcc
#define VEFCC
#define __tcvws
#define __tcfcv
#define __tcfdv

//integration types
#define IT_NSIMTYPE 6
#define IT_EULER 0
#define IT_DIFFERENCE 2
#define IT_RK2F 3
#define IT_RK2 4
#define IT_RK4F 5
#define IT_RK4 1

// error types
#define NOT_ERROR 0
#define CONT_ERROR 1
#define NOT_USED 2
#define WARNING 3
#define NOT_DEFINED 4
#define VERROR 5
#define INFORM 6
#define YIELD 7
#define STOP 8
#define FATAL 9
#define PROGRAM 10

typedef unsigned char charutf8;
typedef unsigned short V2BYTEU;
typedef signed short V2BYTES;
typedef unsigned long V4BYTEU;
typedef signed long V4BYTES;
typedef intmax_t V8BYTES;
typedef float REAL;
typedef double BigREAL;
typedef double COMPREAL;
typedef V8BYTES VAL_OFF;
typedef V4BYTES SUBVAL_OFF;
typedef V4BYTEU *BBASE; /* block base */
typedef V4BYTEU BWORD; /* word type for a block */
typedef V4BYTEU VCOLOR; /* used for color passing and storing */
typedef V2BYTEU OB_INDEX;
typedef V4BYTEU BLK_OFFSET;
typedef V4BYTEU ST_INDEX;
typedef V4BYTEU ST_INDEX_VDF;
typedef V4BYTES SST_IND; /* sorted symbol table index (ST_INDEX should be called ST_OFFSET) */
typedef V8BYTES VFILE_OFF;
typedef V4BYTES EDLINE_IND;
typedef V2BYTES VDF_VALCOUNT;
typedef V4BYTES VMUTEX;

#define DESCRIPT_LEN 75

//Simulation states
#define SS_IDLE			0 // GV.simulation_state
#define SS_SETUP		1 // reading constant changes etc
#define SS_ONSCREEN		2 // getting changes from sketch screen
#define SS_ANALOGSIM	3 // in response to any change perform a simulation
#define SS_LOCKED		4 // GV.LEVEL is locked - no user interaction
#define SS_INIT			5 //
#define SS_ACTIVE		6 // simulation is running
#define SS_INTEG		7 // integration is in process - suppress messages

//Maximum dimensions
#define MAX_DIM 8

#define DATA_MATRIX_KEY   0x33F27413
#define CONSTANT_MATRIX_KEY 0xF722438E

#define LOOKUP_MISS_XGAP (REAL)4096.0

#define VENSIM_INT						unsigned long long

#define MAX_LINE_LEN 1024 // file line lengths for editor, parse etc

#define __int64  int

#define HBLK_HEAD void
#define BHANDLE void**
#define EXP_BD void

typedef union tag_vhndl_ptr
{
	BLK_OFFSET	offsets[1];
	charutf8	str[4];
	charutf8	abstract[4]; /* other types not yet defined */
} *VHANDLE_PTR;

typedef VHANDLE_PTR VHANDLE;


#ifndef ASSERT
#define ASSERT(in)
#endif

#define __tcfdc
#define CFUNCTION
#define of2tabval(off) off

#ifdef WASM
//typedef wchar_t UNICODE_CHAR; /* native on both Windows and Mac - wchar_t is 4 bytes on unix/mac */
#endif

#endif

