#pragma once

/********************************************
wasm_vensim.h Copyright Ventana Systems, Inc.
*********************************************/

#ifndef _WASM_VENSIM_FUNCTIONS_H_
#define _WASM_VENSIM_FUNCTIONS_H_

//void vec_arglist_init();

double MAX(double a, double b);
double MIN(double a, double b);

#define TINY 1e-6 
#define FIRST_IF_TRUE(a,b,c) ((a)?(b):(c)) 
#define IF_THEN_ELSE(a,b,c) ((a)?(b):(c)) 
//#define ABS(a) ((a)>0?(a):-(a)) 
#define ABS(a) fabs(a)
#define LOG(a,b) (log(a)/log(b)) 
#define LN(a)  (log(a)) 
#define XIDZ(n,a,b,c) ((temp[n]=(b)) <= TINY && temp[n] > -TINY?(c):(a)/temp[n])
#define ZIDZ(n,a,b) ((temp[n]=(b)) <= TINY && temp[n] > -TINY?0:(a)/temp[n])
#define EXP(a) exp(a) 
#define COS(a) cos(a) 
#define COSH(a) cosh(a) 
#define SIN(a) sin(a) 
#define SINH(a) sinh(a) 
#define ARCCOS(a) acos(a) 
#define ARCSIN(a) asin(a) 
#define ARCTAN(a) atan(a) 
#define TAN(a) tan(a) 
#define TANH(a) tanh(a) 
#define SQRT(a) sqrt(a) 
#define INTEGER(a) ((COMPREAL)((long)(a)))

//BigREAL MESSAGE(char *msg, BigREAL severity);
void VEFCC vselect_error(int action, int errtype, int elmcount);

BigREAL _VECTOR_REORDER(__tcfdc VECTOR_ARG *outvector, VECTOR_ARG *invector, VECTOR_ARG *sortvector);
#define VECTOR_REORDER(a,b,c) _VECTOR_REORDER(__tcfcc a,b,c)

BigREAL _VECTOR_SORT_ORDER(__tcfdc VECTOR_ARG *outvector, VECTOR_ARG *invector, BigREAL direction);
#define VECTOR_SORT_ORDER(a,b,c) _VECTOR_SORT_ORDER(__tcfcc a,b,c)

BigREAL _VECTOR_RANK(__tcfdc VECTOR_ARG *outvector, VECTOR_ARG *invector, BigREAL direction);
#define VECTOR_RANK(a,b,c) _VECTOR_RANK(__tcfcc a,b,c)

int execute_curloop();
void brzero_free_working_memory();
BigREAL _FIND_ZERO(__tcfdc VECTOR_ARG *vx, VECTOR_ARG *vsx, VECTOR_ARG *vz, VECTOR_ARG *vsz, VECTOR_ARG *inix, BigREAL fn, BigREAL fns, BigREAL tolerance, BigREAL fmax_iter, BigREAL method);
#define FIND_ZERO(a,b,c,d,e,f,g,h,i,j) _FIND_ZERO(__tcfcc a,b,c,d,e,f,g,h,i,j)

BigREAL _INVERT_MATRIX(VECTOR_ARG *ainv, VECTOR_ARG *a, BigREAL n);
#define INVERT_MATRIX(VECTOR_ARG_painv, VECTOR_ARG_pa, BigREAL_n) _INVERT_MATRIX(__tcfcc VECTOR_ARG_painv, VECTOR_ARG_pa, BigREAL_n)

BigREAL GAMMA_LN(BigREAL a);
BigREAL _SHIFT_IF_TRUE(VECTOR_ARG *array, BigREAL cond, BigREAL arrsize, BigREAL cumulate, BigREAL startval);
#define SHIFT_IF_TRUE(VECTOR_ARG_parray, BigREAL_cond, BigREAL_arrsize, BigREAL_cumulate, BigREAL_startval) _SHIFT_IF_TRUE(VECTOR_ARG_parray, BigREAL_cond, BigREAL_arrsize, BigREAL_cumulate, BigREAL_startval);

BigREAL _MARKETP(__tcfdc VECTOR_ARG *request, VECTOR_ARG *priority, int  size, BigREAL  width, BigREAL  supply);
#define MARKETP(a,b,c,d,e) _MARKETP(__tcfcc a,b,c,d,e)

BigREAL _ALLOCATE_BY_PRIORITY(__tcfdc VECTOR_ARG *allocation, VECTOR_ARG *request, VECTOR_ARG *priority, int  size, BigREAL  width, BigREAL  supply);
#define ALLOCATE_BY_PRIORITY(a,b,c,d,e,f) _ALLOCATE_BY_PRIORITY(__tcfcc a,b,c,d,e,f) 

BigREAL _ALLOCATE_AVAILABLE(__tcfdc VECTOR_ARG *allocation, VECTOR_ARG *request, VECTOR_ARG *request_p, BigREAL available);
#define ALLOCATE_AVAILABLE(a,b,c,d) _ALLOCATE_AVAILABLE(__tcfcc a,b,c,d) 

BigREAL _MARKET_MATCH(__tcfdc VECTOR_ARG *sales, VECTOR_ARG *demandq, VECTOR_ARG *dshape, VECTOR_ARG *seller_attract, VECTOR_ARG *supplyq, VECTOR_ARG *sshape, VECTOR_ARG *buyer_priority, VECTOR_ARG *dqsconversion);
#define MARKET_MATCH(a,b,c,d,e,f,g,h) _MARKET_MATCH(__tcfcc a,b,c,d,e,f,g,h)

BigREAL _FIND_MARKET_PRICE(__tcfdc VECTOR_ARG *d, VECTOR_ARG *d_p, VECTOR_ARG *s, VECTOR_ARG *sp);
#define FIND_MARKET_PRICE(a,b,c,d) _FIND_MARKET_PRICE(__tcfcc a,b,c,d)

BigREAL _MARKET_DS(__tcfdc VECTOR_ARG *ds, VECTOR_ARG *ds_p, BigREAL price, int isdemand);
#define MARKET_DS(a,b,c,d) _MARKET_DS(__tcfcc a,b,c,d)

#define DEMAND_AT_PRICE(ds,ds_p,p) MARKET_DS(ds,ds_p,p,1)
#define SUPPLY_AT_PRICE(ds,ds_p,p) MARKET_DS(ds,ds_p,p,0)

BigREAL ALLOC_P(BigREAL request, BigREAL priority, BigREAL width, BigREAL mp);

BigREAL _TIME_BASE(BigREAL intecept, BigREAL slope);
#define TIME_BASE(intecept, slope) _TIME_BASE(intecept, slope);

BigREAL INIT_SINTEG(int type, VAL_OFF deloff, VAL_OFF valoff, double initval, double minval, double maxval, double quantval, double specval, double tolerance);
BigREAL POWER(BigREAL base, BigREAL exponent);
BigREAL VECTOR_ELM_MAP(VECTOR_ARG *in, BigREAL shift);
BigREAL VECTOR_LOOKUP(VECTOR_ARG *in, BigREAL x, BigREAL xmin, BigREAL xmax, BigREAL mode);
BigREAL GET_DATA_AT_TIME(VECTOR_ARG *v, BigREAL t);
BigREAL GET_DATA_BETWEEN_TIMES(VECTOR_ARG *v, BigREAL t, BigREAL mode);
BigREAL GET_DATA_ATTRIBUTE(int attrib, VECTOR_ARG *v, BigREAL t, BigREAL mode);
BigREAL GET_DATA_FIRST_TIME(VECTOR_ARG *v);
BigREAL GET_DATA_LAST_TIME(VECTOR_ARG *v);
BigREAL GET_DATA_TOTAL_POINTS(VECTOR_ARG *v);
BigREAL GET_TIME_VALUE(BigREAL relativeto, BigREAL offset, BigREAL measure);

BigREAL QUEUE_AGE_AVERAGE(VECTOR_ARG *v, BigREAL x);
BigREAL QUEUE_AGE_OLDEST(VECTOR_ARG *v);
BigREAL QUEUE_AGE_IN_RANGE(VECTOR_ARG *v, BigREAL l, BigREAL h);
BigREAL QUEUE_ATTRIB_AVERAGE(VECTOR_ARG *v, BigREAL x);
BigREAL QUEUE_ATTRIB_MAX(VECTOR_ARG *v);
BigREAL QUEUE_ATTRIB_MIN(VECTOR_ARG *v);
BigREAL QUEUE_ATTRIB_IN_RANGE(VECTOR_ARG *v, BigREAL l, BigREAL h);
BigREAL QUEUE_ATTRIB_QUANTITY(VECTOR_ARG *v, BigREAL x);

BigREAL _RAMP(BigREAL  a, BigREAL  b, BigREAL c);
#define RAMP(a,b,c) _RAMP(__tcfcc a,b,c)

BigREAL _PULSE(BigREAL  ftime, BigREAL  width);
#define PULSE(f,w) _PULSE(__tcfcc f,w)

BigREAL _PULSE_TRAIN(BigREAL  ftime, BigREAL  width, BigREAL repeattime, BigREAL stop);
#define PULSE_TRAIN(ftime, width, repeattime, stop) _PULSE_TRAIN(__tcfcc ftime, width, repeattime, stop)

BigREAL MODULO(BigREAL a, BigREAL b);

BigREAL _STEP(BigREAL  a, BigREAL  b);
#define STEP(a,b) _STEP(__tcfcc a,b)

BigREAL QUANTUM(BigREAL a, BigREAL b);

BigREAL _random_beta(__tcfdc int fromopt, BigREAL xmin, BigREAL xmax, BigREAL alpha, BigREAL beta, BigREAL shift, BigREAL stretch, BigREAL streamid);
BigREAL _random_binomial(__tcfdc int fromopt, BigREAL xmin, BigREAL xmax, BigREAL p, BigREAL n, BigREAL shift, BigREAL stretch, BigREAL streamid);
BigREAL _random_negative_binomial(__tcfdc int fromopt, BigREAL xmin, BigREAL xmax, BigREAL p, BigREAL n, BigREAL shift, BigREAL stretch, BigREAL streamid);
BigREAL _random_exponential(__tcfdc int fromopt, BigREAL xmin, BigREAL xmax, BigREAL shift, BigREAL stretch, BigREAL streamid);
BigREAL _random_gamma(__tcfdc int fromopt, BigREAL xmin, BigREAL xmax, BigREAL a, BigREAL shift, BigREAL stretch, BigREAL streamid);
BigREAL _random_lookup(__tcfdc int fromopt, TAB_TYPE *tab, BigREAL xmin, BigREAL xmax, BigREAL shift, BigREAL stretch, BigREAL streamid);
BigREAL _random_normal(__tcfdc int fromopt, BigREAL xmin, BigREAL xmax, BigREAL shift, BigREAL stretch, BigREAL streamid);
BigREAL _random_poisson(__tcfdc int fromopt, BigREAL xmin, BigREAL xmax, BigREAL a, BigREAL shift, BigREAL stretch, BigREAL streamid);
BigREAL _random_triangular(__tcfdc int fromopt, BigREAL xmin, BigREAL xmax, BigREAL peak, BigREAL shift, BigREAL stretch, BigREAL streamid);
BigREAL _random_uniform(__tcfdc int fromopt, BigREAL xmin, BigREAL xmax, BigREAL streamid);
BigREAL _random_weibull(__tcfdc int fromopt, BigREAL xmin, BigREAL xmax, BigREAL shape, BigREAL shift, BigREAL stretch, BigREAL streamid);
BigREAL _ran(__tcfdc int fromopt, BigREAL streamid);

#define random_beta(fromopt,xmin,xmax,alpha,beta,shift,stretch,streamid) _random_beta(__tcfcc fromopt,xmin,xmax,alpha,beta,shift,stretch,streamid)
#define random_binomial(fromopt,xmin,xmax,p,n,shift,stretch,streamid) _random_binomial(__tcfcc fromopt,xmin,xmax,p,n,shift,stretch,streamid) 
#define random_negative_binomial(fromopt,xmin,xmax,p,n,shift,stretch,streamid) _random_negative_binomial(__tcfcc fromopt,xmin,xmax,p,n,shift,stretch,streamid)
#define random_exponential(fromopt,xmin,xmax,shift,stretch,streamid) _random_exponential(__tcfcc fromopt,xmin,xmax,shift,stretch,streamid)
#define random_gamma(fromopt,xmin,xmax,a,shift,stretch,streamid) _random_gamma(__tcfcc fromopt,xmin,xmax,a,shift,stretch,streamid)
#define random_lookup(fromopt,tab,xmin,xmax,shift,stretch,streamid) _random_lookup(__tcfcc fromopt,tab,xmin,xmax,shift,stretch,streamid)
#define random_normal(fromopt,xmin,xmax,shift,stretch,streamid) _random_normal(__tcfcc fromopt,xmin,xmax,shift,stretch,streamid)
#define random_poisson(fromopt,xmin,xmax,a,shift,stretch,streamid) _random_poisson(__tcfcc fromopt,xmin,xmax,a,shift,stretch,streamid)
#define random_triangular(fromopt,xmin,xmax,peak,shift,stretch,streamid) _random_triangular(__tcfcc fromopt,xmin,xmax,peak,shift,stretch,streamid)
#define random_uniform(fromopt,xmin,xmax,streamid) _random_uniform(__tcfcc fromopt,xmin,xmax,streamid)
#define random_weibull(fromopt,xmin,xmax,shape,shift,stretch,streamid) _random_weibull(__tcfcc fromopt,xmin,xmax,shape,shift,stretch,streamid)
#define ran(fromopt,streamid) _ran(__tcfcc fromopt,streamid)
#define ran_clean(a) _ran_clean(__tcfcc a) 
#define ran_reset(fromopt) _ran_reset(__tcfcc fromopt)
#define random_sim_record() _random_sim_record(__tcfcv)
#define random_sim_restore() _random_sim_restore(__tcfcv)

#define RANDOM_0_1() random_uniform(0, 0.0, 1.0, 0.0)
#define RANDOM_BETA(xmin,xmax,alpha,beta,shift,stretch,streamid) _random_beta(__tcfcc 0,xmin,xmax,alpha,beta,shift,stretch,streamid)
#define RANDOM_BINOMIAL(xmin,xmax,p,n,shift,stretch,streamid) _random_binomial(__tcfcc 0,xmin,xmax,p,n,shift,stretch,streamid) 
#define RANDOM_EXPONENTIAL(xmin,xmax,shift,stretch,streamid) _random_exponential(__tcfcc 0,xmin,xmax,shift,stretch,streamid)
#define RANDOM_GAMMA(xmin,xmax,a,shift,stretch,streamid) _random_gamma(__tcfcc 0,xmin,xmax,a,shift,stretch,streamid)
#define RANDOM_LOOKUP(tab,xmin,xmax,shift,stretch,streamid) _random_lookup(__tcfcc 0,tab,xmin,xmax,shift,stretch,streamid)
#define RANDOM_NEGATIVE_BINOMIAL(xmin,xmax,p,n,shift,stretch,streamid) _random_negative_binomial(__tcfcc 0,xmin,xmax,p,n,shift,stretch,streamid)
#define RANDOM_NORMAL(xmin,xmax,shift,stretch,streamid) _random_normal(__tcfcc 0,xmin,xmax,shift,stretch,streamid)
#define RANDOM_POISSON(xmin,xmax,a,shift,stretch,streamid) _random_poisson(__tcfcc 0,xmin,xmax,a,shift,stretch,streamid)
#define RANDOM_TRIANGULAR(xmin, xmax, peak, shift, stretch, streamid) _random_triangular(__tcfcc 0, xmin, xmax, peak, shift, stretch, streamid)
#define RANDOM_UNIFORM(xmin,xmax,streamid) _random_uniform(__tcfcc 0,xmin,xmax,streamid)
#define RANDOM_WEIBULL(xmin,xmax,shape,shift,stretch,streamid) _random_weibull(__tcfcc 0,xmin,xmax,shape,shift,stretch,streamid)

#ifdef WASM
BigREAL SAMPLE_IF_TRUE(double oldval, double cond, double newval);
#endif
//Lookup
BigREAL _TABLE(__tcfdc TAB_TYPE *tab, BigREAL in);
#define TABLE(tab,in) _TABLE(__tcfcc tab,in)

int _GetTablstInd(__tcfdc TAB_TYPE *pTab);
#define GetTablstInd(pTAB_TYPE) _GetTablstInd(__tcfcc pTAB_TYPE)

BigREAL _LOOKUP_BACKWARD(__tcfdc TAB_TYPE *tab, BigREAL in);
BigREAL _LOOKUP_FORWARD(__tcfdc TAB_TYPE *tab, BigREAL in);
BigREAL _LOOKUP_INVERT(__tcfdc TAB_TYPE *tab, BigREAL in);
BigREAL _LOOKUP_EXTRAPOLATE(__tcfdc TAB_TYPE *tab, BigREAL in);
BigREAL _LOOKUP_AREA(__tcfdc TAB_TYPE *tab, BigREAL start, BigREAL end);
BigREAL _LOOKUP_SLOPE(__tcfdc TAB_TYPE *tab, BigREAL x, BigREAL mode);

#define LOOKUP_BACKWARD(tab,in) _LOOKUP_BACKWARD(__tcfcc tab,in) 
#define LOOKUP_FORWARD(tab,in) _LOOKUP_FORWARD(__tcfcc tab,in) 
#define LOOKUP_INVERT(tab,in) _LOOKUP_INVERT(__tcfcc tab,in) 
#define LOOKUP_EXTRAPOLATE(tab,in) _LOOKUP_EXTRAPOLATE(__tcfcc tab,in) 
#define LOOKUP_AREA(tab,start,end) _LOOKUP_AREA(__tcfcc tab,start,end) 
#define LOOKUP_SLOPE(tab,x,mode) _LOOKUP_SLOPE(__tcfcc tab,x,mode) 

double INIT_PURE_DELAY(__tcfdc int type, VAL_OFF deloff, VAL_OFF valoff, double deltime, double initval, double missval_or_order, TAB_TYPE *tab, TAB_TYPE *tab2);
BigREAL STORE_PURE_DELAY(__tcfdc VAL_OFF deloff, double val, double outval, double delaytime, double changerate, TAB_TYPE *tab);

#define DELAY_FIXED_i(type,varoff,delind,deltime,initval) INIT_PURE_DELAY(type,delind,varoff,deltime,initval,0.0,NULL,NULL) 
#define DELAY_FIXED_a(delind,inval) STORE_PURE_DELAY(delind,inval,0.0,1.0,0,NULL)
#define DELAY_INFORMATION_i(type,varoff,delind,initval) INIT_PURE_DELAY(type,delind,varoff,1.0,initval,0.0,NULL,NULL) 
#define DELAY_INFORMATION_a(delind,inval,deltime) STORE_PURE_DELAY(delind,inval,0.0,deltime,0,NULL)
#define DELAY_MATERIAL_i(type,varoff,delind,initval,missval) INIT_PURE_DELAY(type,delind,varoff,1.0,initval,missval,NULL,NULL) 
#define DELAY_MATERIAL_a(delind,inval,deltime) STORE_PURE_DELAY(delind,inval,0.0,deltime,0,NULL)

#define DELAY_N_i(type,varoff,delind,initval,order) INIT_PURE_DELAY(type,delind,varoff,1.0,initval,order,NULL,NULL)
#define DELAY_N_a(delind,inval,deltime)  STORE_PURE_DELAY(delind,inval,0.0,deltime,0,NULL)
#define SMOOTH_N_i(type,varoff,delind,initval,order) INIT_PURE_DELAY(type,delind,varoff,1.0,initval,order,NULL,NULL)
#define SMOOTH_N_a(delind,inval,deltime)  STORE_PURE_DELAY(delind,inval,0.0,deltime,0,NULL)
#define QUEUE_FIFO_i(type,varoff,delind,initprofile,initval,initage) INIT_PURE_DELAY(type,delind,varoff,initage,initval,0.0,initprofile,NULL)
#define QUEUE_FIFO_a(delind,inval,outval) STORE_PURE_DELAY(delind,inval,outval,1.0,0,NULL) ;
#define QUEUE_FIFO_ATTRIB_i(type,varoff,delind,initprofile,inattribprofile,initval,initattrib,initage) INIT_PURE_DELAY(type,delind,varoff,initage,initval,initattrib,initprofile,inattribprofile)
#define QUEUE_FIFO_ATTRIB_a(delind,inval,outval,inattrib,changerate) STORE_PURE_DELAY(delind,inval,outval,inattrib,changerate,NULL)
#define DELAY_PROFILE_i(type,varoff,delind,initval,initgrowrate) INIT_PURE_DELAY(type,delind,varoff,1.0,initval,initgrowrate,NULL,NULL)
#define DELAY_PROFILE_a(delind,profile,inval,deltime) STORE_PURE_DELAY(delind,inval,0.0,deltime,0,profile)
#define DELAY_CONVEYOR_i(type,varoff,delind,initprofile,inittotal,initctime) INIT_PURE_DELAY(type,delind,varoff,initctime,inittotal,0,initprofile,NULL)
#define DELAY_CONVEYOR_a(delind,inval,deltime,drainage) STORE_PURE_DELAY(delind,inval,drainage,deltime,0,NULL)
#define DELAY_BATCH_i(type,varoff,delind,initbatch,inittime,initbacklog) INIT_PURE_DELAY(type,delind,varoff,inittime,initbatch,initbacklog,NULL,NULL)
#define DELAY_BATCH_a(delind,inval,bsize,deltime) STORE_PURE_DELAY(delind,inval,bsize,deltime,0,NULL)
#define INTERNAL_RATE_OF_RETURN_i(type,varoff,delind,fperiod,initq,initt) INIT_PURE_DELAY(type,delind,varoff,fperiod,initq,initt,NULL,NULL)
#define INTERNAL_RATE_OF_RETURN_a(delind,inval) STORE_PURE_DELAY(delind,inval,0,0,0,NULL)
#define NET_PRESENT_VALUE_i(type,varoff,delind,fperiod,fstart,foff) INIT_PURE_DELAY(type,delind,varoff,fperiod,fstart,foff,NULL,NULL)

#define NET_PRESENT_VALUE_a(delind,inval,dr) STORE_PURE_DELAY(delind,inval,dr,0,0,NULL)
#define DEPRECIATE_BY_SCHEDULE_i(type,varoff,delind,sched,init,it,fstart) INIT_PURE_DELAY(type,delind,varoff,it,fstart,0,(TAB_TYPE *)sched,(TAB_TYPE *)init)
#define DEPRECIATE_BY_SCHEDULE_a(delind,inval) STORE_PURE_DELAY(delind,inval,0,0,0,NULL)
#define DEPRECIATE_STRAIGHTLINE_i(type,varoff,delind,deltime,fperiod,initq) INIT_PURE_DELAY(type,delind,varoff,deltime,initq,fperiod,NULL,NULL)
#define DEPRECIATE_STRAIGHTLINE_a(delind,inval) STORE_PURE_DELAY(delind,inval,0,0,0,NULL)


int VEFCC COMPARE_SIMULT_VALUES(int storeflag);
int _compare_simult_values(__tcfdc int storeflag);
#define compare_simult_values(storeflag) _compare_simult_values(__tcfcc storeflag)

/*
COMPREAL VEFCC DateSerial_Excel(int nYear, int nMonth, int nDay, int nHour, int nMin, int nSec);

COMPREAL VEFCC ExcelDateSerial_YEAR(COMPREAL fExcelSerialDate);
COMPREAL VEFCC ExcelDateSerial_MONTH_OF_YEAR(COMPREAL fExcelSerialDate);
COMPREAL VEFCC ExcelDateSerial_WEEK_OF_YEAR(COMPREAL fExcelSerialDate);
COMPREAL VEFCC ExcelDateSerial_HOUR(COMPREAL fExcelSerialDate);
COMPREAL VEFCC ExcelDateSerial_MINUTE(COMPREAL fExcelSerialDate);
COMPREAL VEFCC ExcelDateSerial_SECOND(COMPREAL fExcelSerialDate);
COMPREAL VEFCC ExcelDateSerial_DAY_OF_YEAR(COMPREAL fExcelSerialDate);
COMPREAL VEFCC ExcelDateSerial_DAY_OF_WEEK(COMPREAL fExcelSerialDate);
COMPREAL VEFCC ExcelDateSerial_DAY_OF_MONTH(COMPREAL fExcelSerialDate);
*/
#define EXCELDATESERIAL(int_nYear, int_nMonth, int_nDay) DateSerial_Excel(int_nYear, int_nMonth, int_nDay, 0, 0, 0);
#define EXCELDATESERIAL_YEAR(BigREAL_fExcelSerialDate) ExcelDateSerial_YEAR(BigREAL_fExcelSerialDate);
#define EXCELDATESERIAL_MONTH_OF_YEAR(BigREAL_fExcelSerialDate) ExcelDateSerial_MONTH_OF_YEAR(BigREAL_fExcelSerialDate);
#define EXCELDATESERIAL_WEEK_OF_YEAR(BigREAL_fExcelSerialDate) ExcelDateSerial_WEEK_OF_YEAR(BigREAL_fExcelSerialDate);
#define EXCELDATESERIAL_HOUR(BigREAL_fExcelSerialDate) ExcelDateSerial_HOUR(BigREAL_fExcelSerialDate);
#define EXCELDATESERIAL_MINUTE(BigREAL_fExcelSerialDate) ExcelDateSerial_MINUTE(BigREAL_fExcelSerialDate);
#define EXCELDATESERIAL_SECOND(BigREAL_fExcelSerialDate) ExcelDateSerial_SECOND(BigREAL_fExcelSerialDate);
#define EXCELDATESERIAL_DAY_OF_YEAR(BigREAL_fExcelSerialDate) ExcelDateSerial_DAY_OF_YEAR(BigREAL_fExcelSerialDate);
#define EXCELDATESERIAL_DAY_OF_WEEK(BigREAL_fExcelSerialDate) ExcelDateSerial_DAY_OF_WEEK(BigREAL_fExcelSerialDate);
#define EXCELDATESERIAL_DAY_OF_MONTH(BigREAL_fExcelSerialDate) ExcelDateSerial_DAY_OF_MONTH(BigREAL_fExcelSerialDate);

#endif

