#if defined(__cplusplus)
extern "C"
{
#endif	//#if defined(__cplusplus)


	//Exported functions
	int GetVariableIndex(charutf8 *strVarName);
	long GetNumVariables();
	char *GetVariableName(long nIndex);
	int GetVariableType(long nIndex);
	int GetInterpolationPattern(long nIndex);
	int GetFromVDFFlag(long nIndex);
	//double GetVariableValue(charutf8 *strVarName);
	long GetTimeSeriesNumVals(charutf8 *strVarName);
	long GetTimeSeries(charutf8 *strVarName, double *pTimeVector, double *pResultsVector);
	int RunSim();
	int RunSim_Aux();
	int FindLookup(charutf8 *strTabName);
	int FindConstant(charutf8 *strName);
	void wsource_error(int severe, int nMode, int pos, charutf8 *fmt, ...);
	void v_error(int severe, charutf8 *fmt, ...);
	int SetupTimeConstants();

#define WSOURCE_ERROR_MODE_CIN 1

#ifdef _WASM
#define str_nc_cmp(strA, strB) stringccasecmpfunction(strA,strB)
	//strncasecmp(strA, strB, strlen(strA))
#else
#define str_nc_cmp(strA, strB) _stricmp(strA, strB)
#endif


	enum yytokentype {
		NOT = 1,
		LEFT_PAREN = 2,
		RIGHT_PAREN = 3,
		UMINUS = 4,
		S_EXG = 5,
		S_EXG_DYNAMIC = 6,
		TWO_EXP = 7,
		S_LEVEL = 8,
		S_LAST_LOWLEV = 10,
		S_DATA_RAW = 11,
		S_DATA_EQ = 12,
		S_TIME_BASE = 15,
		S_AUXILIARY = 17,
		S_RATE = 18,
		S_GAMING_VAR = 19,
		S_LAST_DYNAMIC = 21,
		S_INITIAL = 22,
		S_CONSTANT = 23,
		S_UCONSTANT = 24,
		S_LAST_LEVOFF = 25,
		S_LOOKUP = 26,
		S_STRINGVAR = 27,
		S_TEST_INPUT = 28,
		S_CONSTRAINT = 29,
		S_LAST_VISIBLE = 30,
		TABBED_ARRAY = 31,
		PLUS = 35,
		MINUS = 36,
		TIMES = 37,
		EQUALS = 38,
		DIVIDE = 39,
		EXPON = 40,
		AND = 41,
		OR = 42,
		NE = 43,
		LT = 44,
		LE = 45,
		GT = 46,
		GE = 47,
		ELIST = 48,
		SELIST = 49,
		MAP = 50,
		IMPLIES = 51,
		TIME_TRANSITION = 52,
		LOOK_FORWARD = 53,
		HOLD_BACKWARD = 54,
		INTERPOLATE = 55,
		TIME_SHIFT = 56,
		TLT = 57,
		TLE = 58,
		TGT = 59,
		TGE = 60,
		TEQUALS = 61,
		COLON = 63,
		RAW = 64,
		ULFUNCTION = 65,
		SEMICOLON = 66,
		UEQUALS = 67,
		EXCEPT = 68,
		GAMEF = 70,
		INTEG = 71,
		TAB_USE = 72,
		ACTIVE_INIT = 73,
		REINIT = 74,
		NAMERANGE = 75,
		NAMEMAP = 76,
		A_FUNCTION_OF = 77,
		MATERIAL_DELAY = 78,
		INFORMATION_DELAY = 79,
		FIXED_DELAY = 80,
		PURE_ADELAY = 81,
		PURE_DELAY = 82,
		UPDATE_IF_TRUE = 83,
		SINTEG = 84,
		SIMULTANEOUS = 85,
		VIGNORE = 86,
		HALFLEV = 87,
		WITH_LOOKUP = 90,
		NAME_EXP = 130,
		S_FCONST = 131,
		S_FVAR = 132,
		S_UNITS = 135,
		S_WILDCARD = 136,
		S_MACRO = 137,
		S_GROUP = 138,
		S_OPTION = 139,
		S_COMMENTSYM = 140,
		S_LAST_VARTYPE = 142,
		S_FUNCTION = 143,
		S_VFUNCTION = 144,
		S_RC_FUNC = 145,
		S_RC_FUNC_CHECK = 146,
		S_CONSTDEF_FUNC = 147,
		S_DATADEF_FUNC = 148,
		NAME = 149,
		VARIABLE = 150,
		SNLIST = 151,
		FELM = 152,
		EQUIVALENCE = 153,
		MACRONAME = 154,
		MACROCALL = 155,
		MACROUNIT = 156,
		LOOKUP_MNAME = 157,
		ELMCOUNT = 158,
		S_DELAY_FUNCTION = 159,
		S_MEMORY_FUNCTION = 160,
		S_LOOKUPDEF_FUNC = 161,
		S_VSFUNCTION = 162,
		S_SUBDEF_FUNC = 163,
		NUMBER_EXP = 165,
		NUMBER = 166,
		DASHVAL = 167,
		STARVAL = 168,
		COMMENT = 169,
		LITERAL = 170,
		PIPE = 171,
		EXCLAIM = 172,
		BAD_TOKEN = 173,
		EOL_TOKEN = 174,
		EOEQ = 175,
		RIGHT_BRACKET = 176,
		COMMA = 177,
		LEFT_BRACKET = 178,
		QUESTION_MARK = 179,
		X_IF_MISSING = 180,
		CUMULATE = 181,
		CUMULATEF = 182,
		END_OF_MACRO = 183,
		SPACE_TOKEN = 184,
		MSPACE_TOKEN = 185,
		TAB_TOKEN = 186,
		LITERAL_TOKEN = 187,
		CROSSING = 188,
		ONCE = 189,
		S_REMNANT = 255
	};


#if defined(__cplusplus)
}
#endif	//#if defined(__cplusplus)
